Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zprod.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zprod.F90	(revision 12536)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zprod.F90	(revision 12537)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                         ***  MODULE p4zprod  ***
-   !! TOP :  Growth Rate of the two phytoplanktons groups 
+   !! TOP :  Growth Rate of the two phytoplankton groups of PISCES 
    !!======================================================================
    !! History :   1.0  !  2004     (O. Aumont) Original code
@@ -24,5 +24,5 @@
    PUBLIC   p4z_prod         ! called in p4zbio.F90
    PUBLIC   p4z_prod_init    ! called in trcsms_pisces.F90
-   PUBLIC   p4z_prod_alloc
+   PUBLIC   p4z_prod_alloc   ! called in trcini_pisces.F90
 
    REAL(wp), PUBLIC ::   pislopen     !:
@@ -40,5 +40,5 @@
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   quotan   !: proxy of N quota in Nanophyto
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   quotad   !: proxy of N quota in diatomee
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   quotad   !: proxy of N quota in diatoms
    
    REAL(wp) ::   r1_rday    ! 1 / rday
@@ -57,8 +57,8 @@
       !!                     ***  ROUTINE p4z_prod  ***
       !!
-      !! ** Purpose :   Compute the phytoplankton production depending on
-      !!              light, temperature and nutrient availability
-      !!
-      !! ** Method  : - ???
+      !! ** Purpose :   Computes phytoplankton production depending on
+      !!                light, temperature and nutrient availability
+      !!                Computes also the uptake of Iron and Si as well 
+      !!                as the chlorophyll content of the cells
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt, knt   !
@@ -95,5 +95,6 @@
       zmxl_fac(:,:,:) = 0._wp ; zmxl_chl(:,:,:) = 0._wp 
 
-      ! Computation of the optimal production
+      ! Computation of the maximimum production
+      ! Parameters are taken from Bissinger et al. (2008)
       zprmaxn(:,:,:) = 0.8_wp * r1_rday * tgfunc(:,:,:)
       zprmaxd(:,:,:) = zprmaxn(:,:,:)
@@ -114,4 +115,9 @@
 
       ! Impact of the day duration and light intermittency on phytoplankton growth
+      ! Intermittency is supposed to have a similar effect on production as 
+      ! day length. The correcting factor is zmxl_fac. zmxl_chl is the fractional
+      ! day length and is used to compute the mean PAR during daytime.
+      ! Formulation for the impact of day length on PP is from Thompson (1999)
+      ! ------------------------------------------------------------------------- 
       DO jk = 1, jpkm1
          DO jj = 1 ,jpj
@@ -132,8 +138,11 @@
       zprdia(:,:,:) = zprmaxd(:,:,:) * zmxl_fac(:,:,:)
 
-      ! Maximum light intensity
       WHERE( zstrn(:,:) < 1.e0 ) zstrn(:,:) = 24.
 
       ! Computation of the P-I slope for nanos and diatoms
+      ! The formulation proposed by Geider et al. (1997) has been modified 
+      ! to exclude the effect of nutrient limitation and temperature in the PI
+      ! curve following Vichi et al. (2007)
+      ! -----------------------------------------------------------------------
       DO jk = 1, jpkm1
          DO jj = 1, jpj
@@ -145,4 +154,6 @@
                   zconctemp2  = trb(ji,jj,jk,jpdia) - zconctemp
                   !
+                  ! The initial slope of the PI curve can be increased for nano
+                  ! to account for photadaptation, for instance in the DCM
                   zpislopeadn(ji,jj,jk) = pislopen * ( 1.+ zadap  * EXP( -0.25 * enano(ji,jj,jk) ) )  &
                   &                   * trb(ji,jj,jk,jpnch) /( trb(ji,jj,jk,jpphy) * 12. + rtrn)
@@ -179,4 +190,5 @@
 
       !  Computation of a proxy of the N/C ratio
+      !  Steady state is assumed
       !  ---------------------------------------
       DO jk = 1, jpkm1
@@ -199,9 +211,10 @@
 
                 IF( etot_ndcy(ji,jj,jk) > 1.E-3 ) THEN
-                   !    Si/C of diatoms
-                   !    ------------------------
-                   !    Si/C increases with iron stress and silicate availability
-                   !    Si/C is arbitrariliy increased for very high Si concentrations
-                   !    to mimic the very high ratios observed in the Southern Ocean (silpot2)
+                   ! Si/C of diatoms
+                   ! ------------------------
+                   ! Si/C increases with iron stress and silicate availability (zsilfac)
+                   ! Si/C is arbitrariliy increased for very high Si concentrations
+                   ! to mimic the very high ratios observed in the Southern Ocean (zsilfac2)
+                   ! -----------------------------------------------------------------------
                   zlim  = trb(ji,jj,jk,jpsil) / ( trb(ji,jj,jk,jpsil) + xksi1 )
                   zsilim = MIN( zprdia(ji,jj,jk) / ( zprmaxd(ji,jj,jk) + rtrn ), xlimsi(ji,jj,jk) )
@@ -219,7 +232,7 @@
       END DO
 
-      !  Mixed-layer effect on production 
-      !  Sea-ice effect on production
-
+      ! Sea-ice effect on production
+      ! No production is assumed below sea ice
+      ! -------------------------------------- 
       DO jk = 1, jpkm1
          DO jj = 1, jpj
@@ -231,14 +244,22 @@
       END DO
 
-      ! Computation of the various production terms 
+      ! Computation of the various production  and nutrient uptake terms
+      ! ---------------------------------------------------------------
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
                IF( etot_ndcy(ji,jj,jk) > 1.E-3 ) THEN
-                  !  production terms for nanophyto. (C)
+                  !  production term of nanophyto. (C)
                   zprorcan(ji,jj,jk) = zprbio(ji,jj,jk)  * xlimphy(ji,jj,jk) * trb(ji,jj,jk,jpphy) * rfact2
+
+                  !  New production (uptake of NO3)
                   zpronewn(ji,jj,jk)  = zprorcan(ji,jj,jk)* xnanono3(ji,jj,jk) / ( xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk) + rtrn )
                   !
                   zratio = trb(ji,jj,jk,jpnfe) / ( trb(ji,jj,jk,jpphy) * fecnm + rtrn )
+
+                  !  Iron uptake rates of nanophytoplankton. Upregulation  
+                  !  is parameterized at low iron concentrations. Typical 
+                  !  formulation used in quota formulations. Uptake is downregulated
+                  !  when the quota is close to the maximum quota 
                   zmax   = MAX( 0., ( 1. - zratio ) / ABS( 1.05 - zratio ) ) 
                   zprofen(ji,jj,jk) = fecnm * zprmaxn(ji,jj,jk) * ( 1.0 - fr_i(ji,jj) )  &
@@ -246,8 +267,14 @@
                   &             * biron(ji,jj,jk) / ( biron(ji,jj,jk) + concnfe(ji,jj,jk) )  &
                   &             * zmax * trb(ji,jj,jk,jpphy) * rfact2
-                  !  production terms for diatoms (C)
+                  !  production terms of diatoms (C)
                   zprorcad(ji,jj,jk) = zprdia(ji,jj,jk) * xlimdia(ji,jj,jk) * trb(ji,jj,jk,jpdia) * rfact2
+
+                  ! New production (uptake of NO3)
                   zpronewd(ji,jj,jk) = zprorcad(ji,jj,jk) * xdiatno3(ji,jj,jk) / ( xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk) + rtrn )
-                  !
+
+                  !  Iron uptake rates of nanophytoplankton. Upregulation  
+                  !  is parameterized at low iron concentrations. Typical 
+                  !  formulation used in quota formulations. Uptake is downregulated
+                  !  when the quota is close to the maximum quota 
                   zratio = trb(ji,jj,jk,jpdfe) / ( trb(ji,jj,jk,jpdia) * fecdm + rtrn )
                   zmax   = MAX( 0., ( 1. - zratio ) / ABS( 1.05 - zratio ) ) 
@@ -262,19 +289,25 @@
 
       ! Computation of the chlorophyll production terms
+      ! The parameterization is taken from Geider et al. (1997)
+      ! -------------------------------------------------------
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
                IF( etot_ndcy(ji,jj,jk) > 1.E-3 ) THEN
-                  !  production terms for nanophyto. ( chlorophyll )
+                  !  production term for nanophyto. ( chlorophyll )
                   znanotot = enanom(ji,jj,jk) / ( zmxl_chl(ji,jj,jk) + rtrn )
                   zprod    = rday * zprorcan(ji,jj,jk) * zprchln(ji,jj,jk) * xlimphy(ji,jj,jk)
                   zprochln = chlcmin * 12. * zprorcan (ji,jj,jk)
+                  ! The maximum reachable Chl quota is modulated by temperature
+                  ! following Geider (1987)
                   chlcnm_n   = MIN ( chlcnm, ( chlcnm / (1. - 1.14 / 43.4 *tsn(ji,jj,jk,jp_tem))) * (1. - 1.14 / 43.4 * 20.))
                   zprochln = zprochln + (chlcnm_n-chlcmin) * 12. * zprod / &
                                         & (  zpislopeadn(ji,jj,jk) * znanotot +rtrn)
-                  !  production terms for diatoms ( chlorophyll )
+                  !  production terms of diatoms ( chlorophyll )
                   zdiattot = ediatm(ji,jj,jk) / ( zmxl_chl(ji,jj,jk) + rtrn )
                   zprod    = rday * zprorcad(ji,jj,jk) * zprchld(ji,jj,jk) * xlimdia(ji,jj,jk)
                   zprochld = chlcmin * 12. * zprorcad(ji,jj,jk)
+                  ! The maximum reachable Chl quota is modulated by temperature
+                  ! following Geider (1987)
                   chlcdm_n   = MIN ( chlcdm, ( chlcdm / (1. - 1.14 / 43.4 * tsn(ji,jj,jk,jp_tem))) * (1. - 1.14 / 43.4 * 20.))
                   zprochld = zprochld + (chlcdm_n-chlcmin) * 12. * zprod / &
@@ -319,4 +352,9 @@
      END DO
      !
+     ! Production and uptake of ligands by phytoplankton. This part is activated 
+     ! when ln_ligand is set to .true. in the namelist. Ligand uptake is small 
+     ! and based on the FeL model by Morel et al. (2008) and on the study of
+     ! Shaked and Lis (2012)
+     ! -------------------------------------------------------------------------
      IF( ln_ligand ) THEN
          zpligprod1(:,:,:) = 0._wp    ;    zpligprod2(:,:,:) = 0._wp
@@ -328,7 +366,8 @@
                     zfeup    = texcretn * zprofen(ji,jj,jk) + texcretd * zprofed(ji,jj,jk)
                     tra(ji,jj,jk,jplgw) = tra(ji,jj,jk,jplgw) + zdocprod * ldocp    &
-                    &       - zfeup * plig(ji,jj,jk) / ( rtrn + plig(ji,jj,jk) + 2.E3 * (1.0 - plig(ji,jj,jk) ) )
+                    &       - zfeup * plig(ji,jj,jk) / ( rtrn + plig(ji,jj,jk) + 2.E3 * (1.0 - plig(ji,jj,jk) ) ) * lthet
                     zpligprod1(ji,jj,jk) = zdocprod * ldocp
-                    zpligprod2(ji,jj,jk) = zfeup * plig(ji,jj,jk) * lthet
+                    zpligprod2(ji,jj,jk) = zfeup * plig(ji,jj,jk) / ( rtrn + plig(ji,jj,jk) &
+                    &                      + 2.E3 * (1.0 - plig(ji,jj,jk) ) ) * lthet
                  ENDIF
               END DO
@@ -373,9 +412,9 @@
           ENDIF
           IF( iom_use( "LPRODP" ) )  THEN
-              zw3d(:,:,:) = zpligprod1(:,:,:) * 1e9 * zfact * tmask(:,:,:)
+              zw3d(:,:,:) = zpligprod1(:,:,:) * 1e9 * zfact * tmask(:,:,:)  ! Ligand production by phytoplankton
               CALL iom_put( "LPRODP"  , zw3d )
           ENDIF
           IF( iom_use( "LDETP" ) )  THEN
-              zw3d(:,:,:) = zpligprod2(:,:,:) * 1e9 * zfact * tmask(:,:,:)
+              zw3d(:,:,:) = zpligprod2(:,:,:) * 1e9 * zfact * tmask(:,:,:)  ! Uptake of ligands by phytoplankton
               CALL iom_put( "LDETP"  , zw3d )
           ENDIF
@@ -392,8 +431,8 @@
           ENDIF
           IF( iom_use( "LNlight" ) .OR. iom_use( "LDlight" ) )  THEN
-              zw3d(:,:,:) = zprbio (:,:,:) / (zprmaxn(:,:,:) + rtrn) * tmask(:,:,:) ! light limitation term
+              zw3d(:,:,:) = zprbio (:,:,:) / (zprmaxn(:,:,:) + rtrn) * tmask(:,:,:) ! light limitation term of nanophytoplankton
               CALL iom_put( "LNlight"  , zw3d )
               !
-              zw3d(:,:,:) = zprdia (:,:,:) / (zprmaxd(:,:,:) + rtrn) * tmask(:,:,:)  ! light limitation term
+              zw3d(:,:,:) = zprdia (:,:,:) / (zprmaxd(:,:,:) + rtrn) * tmask(:,:,:)  ! light limitation term of diatoms
               CALL iom_put( "LDlight"  , zw3d )
           ENDIF
@@ -474,8 +513,8 @@
       !! ** Purpose :   Initialization of phytoplankton production parameters
       !!
-      !! ** Method  :   Read the nampisprod namelist and check the parameters
+      !! ** Method  :   Read the namp4zprod namelist and check the parameters
       !!      called at the first timestep (nittrc000)
       !!
-      !! ** input   :   Namelist nampisprod
+      !! ** input   :   Namelist namp4zprod
       !!----------------------------------------------------------------------
       INTEGER ::   ios   ! Local integer
@@ -491,8 +530,8 @@
       ENDIF
       !
-      REWIND( numnatp_ref )              ! Namelist nampisprod in reference namelist : Pisces phytoplankton production
+      REWIND( numnatp_ref )              ! Namelist namp4zprod in reference namelist : Pisces phytoplankton production
       READ  ( numnatp_ref, namp4zprod, IOSTAT = ios, ERR = 901)
 901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namp4zprod in reference namelist' )
-      REWIND( numnatp_cfg )              ! Namelist nampisprod in configuration namelist : Pisces phytoplankton production
+      REWIND( numnatp_cfg )              ! Namelist namp4zprod in configuration namelist : Pisces phytoplankton production
       READ  ( numnatp_cfg, namp4zprod, IOSTAT = ios, ERR = 902 )
 902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namp4zprod in configuration namelist' )
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zrem.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zrem.F90	(revision 12536)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zrem.F90	(revision 12537)
@@ -3,4 +3,6 @@
    !!                         ***  MODULE p4zrem  ***
    !! TOP :   PISCES Compute remineralization/dissolution of organic compounds
+   !!         except for POC which is treated in p4zpoc.F90
+   !!         This module is common to both PISCES and PISCES-QUOTA
    !!=========================================================================
    !! History :   1.0  !  2004     (O. Aumont) Original code
@@ -17,5 +19,5 @@
    USE p4zche          !  chemical model
    USE p4zprod         !  Growth rate of the 2 phyto groups
-   USE p4zlim
+   USE p4zlim          !  Nutrient limitation terms
    USE prtctl_trc      !  print control for debugging
    USE iom             !  I/O manager
@@ -26,17 +28,18 @@
 
    PUBLIC   p4z_rem         ! called in p4zbio.F90
-   PUBLIC   p4z_rem_init    ! called in trcsms_pisces.F90
-   PUBLIC   p4z_rem_alloc
-
-   REAL(wp), PUBLIC ::   xremikc    !: remineralisation rate of DOC 
-   REAL(wp), PUBLIC ::   xremikn    !: remineralisation rate of DON 
-   REAL(wp), PUBLIC ::   xremikp    !: remineralisation rate of DOP 
-   REAL(wp), PUBLIC ::   xremik     !: remineralisation rate of POC 
+   PUBLIC   p4z_rem_init    ! called in trcini_pisces.F90
+   PUBLIC   p4z_rem_alloc   ! called in trcini_pisces.F90
+
+   !! * Shared module variables
+   REAL(wp), PUBLIC ::   xremikc    !: remineralisation rate of DOC (p5z) 
+   REAL(wp), PUBLIC ::   xremikn    !: remineralisation rate of DON (p5z) 
+   REAL(wp), PUBLIC ::   xremikp    !: remineralisation rate of DOP (p5z) 
+   REAL(wp), PUBLIC ::   xremik     !: remineralisation rate of DOC (p4z) 
    REAL(wp), PUBLIC ::   nitrif     !: NH4 nitrification rate 
-   REAL(wp), PUBLIC ::   xsirem     !: remineralisation rate of POC 
-   REAL(wp), PUBLIC ::   xsiremlab  !: fast remineralisation rate of POC 
+   REAL(wp), PUBLIC ::   xsirem     !: remineralisation rate of biogenic silica
+   REAL(wp), PUBLIC ::   xsiremlab  !: fast remineralisation rate of BSi
    REAL(wp), PUBLIC ::   xsilab     !: fraction of labile biogenic silica 
    REAL(wp), PUBLIC ::   feratb     !: Fe/C quota in bacteria
-   REAL(wp), PUBLIC ::   xkferb     !: Half-saturation constant for bacteria Fe/C
+   REAL(wp), PUBLIC ::   xkferb     !: Half-saturation constant for bacterial Fe/C
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   denitr   !: denitrification array
@@ -53,7 +56,13 @@
       !!                     ***  ROUTINE p4z_rem  ***
       !!
-      !! ** Purpose :   Compute remineralization/scavenging of organic compounds
-      !!
-      !! ** Method  : - ???
+      !! ** Purpose :   Compute remineralization/dissolution of organic compounds
+      !!                Computes also nitrification of ammonium 
+      !!                The solubilization/remineralization of POC is treated 
+      !!                in p4zpoc.F90. The dissolution of calcite is processed
+      !!                in p4zlys.F90. 
+      !!
+      !! ** Method  : - Bacterial biomass is computed implicitely based on a 
+      !!                parameterization developed from an explicit modeling
+      !!                of PISCES in an alternative version 
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt, knt ! ocean time step
@@ -73,5 +82,5 @@
       IF( ln_timing )   CALL timing_start('p4z_rem')
       !
-      ! Initialisation of arrys
+      ! Initialisation of arrays
       zdepprod(:,:,:) = 1._wp
       zdepeff (:,:,:) = 0.3_wp
@@ -81,6 +90,5 @@
       zfacsi(:,:,:)   = xsilab
 
-      ! Computation of the mean phytoplankton concentration as
-      ! a crude estimate of the bacterial biomass
+      ! Computation of the mean bacterial concentration
       ! this parameterization has been deduced from a model version
       ! that was modeling explicitely bacteria
@@ -107,17 +115,24 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  ! DOC ammonification. Depends on depth, phytoplankton biomass
-                  ! and a limitation term which is supposed to be a parameterization of the bacterial activity. 
+                  ! DOC ammonification. Depends on a limitation term of the bacterial activity
+                  ! and on the implicit bacteria concentration
+                  ! --------------------------------------------------------------------------
                   zremik = xremik * xstep / 1.e-6 * xlimbac(ji,jj,jk) * zdepbac(ji,jj,jk) 
                   zremik = MAX( zremik, 2.74e-4 * xstep )
+
                   ! Ammonification in oxic waters with oxygen consumption
                   ! -----------------------------------------------------
                   zolimit = zremik * ( 1.- nitrfac(ji,jj,jk) ) * trb(ji,jj,jk,jpdoc) 
                   zolimi(ji,jj,jk) = MIN( ( trb(ji,jj,jk,jpoxy) - rtrn ) / o2ut, zolimit ) 
+
                   ! Ammonification in suboxic waters with denitrification
-                  ! -------------------------------------------------------
+                  ! -----------------------------------------------------
                   zammonic = zremik * nitrfac(ji,jj,jk) * trb(ji,jj,jk,jpdoc)
                   denitr(ji,jj,jk)  = zammonic * ( 1. - nitrfac2(ji,jj,jk) )
                   denitr(ji,jj,jk)  = MIN( ( trb(ji,jj,jk,jpno3) - rtrn ) / rdenit, denitr(ji,jj,jk) )
+
+                  ! Ammonification in waters depleted in O2 and NO3 based on 
+                  ! other redox processes
+                  ! --------------------------------------------------------
                   zoxyremc          = zammonic - denitr(ji,jj,jk)
                   !
@@ -125,6 +140,5 @@
                   denitr (ji,jj,jk) = MAX( 0.e0, denitr (ji,jj,jk) )
                   zoxyremc          = MAX( 0.e0, zoxyremc )
-
-                  !
+                  ! Update of the TRA arrays
                   tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) + zolimi (ji,jj,jk) + denitr(ji,jj,jk) + zoxyremc
                   tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) + zolimi (ji,jj,jk) + denitr(ji,jj,jk) + zoxyremc
@@ -142,7 +156,8 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  ! DOC ammonification. Depends on depth, phytoplankton biomass
-                  ! and a limitation term which is supposed to be a parameterization of the bacterial activity. 
-                  ! -----------------------------------------------------------------
+                  ! DOC ammonification. Depends on a limitation term of the bacterial activity
+                  ! and on the implicit bacteria concentration
+                  ! ---------------------------------------------------------------
+-----------
                   zremik = xstep / 1.e-6 * MAX(0.01, xlimbac(ji,jj,jk)) * zdepbac(ji,jj,jk) 
                   zremik = MAX( zremik, 2.74e-4 * xstep / xremikc )
@@ -170,5 +185,5 @@
                   zoxyremn  = zremikn * zoxyremc * trb(ji,jj,jk,jpdon) / ( trb(ji,jj,jk,jpdoc) + rtrn )
                   zoxyremp  = zremikp * zoxyremc * trb(ji,jj,jk,jpdop) / ( trb(ji,jj,jk,jpdoc) + rtrn )
-
+                  ! Update of the TRA arrays
                   tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) + zolimip + zdenitrp + zoxyremp
                   tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) + zolimin + zdenitrn + zoxyremn
@@ -185,5 +200,4 @@
          !
       ENDIF
-
 
       DO jk = 1, jpkm1
@@ -220,8 +234,12 @@
                ! Bacteries are obliged to take up iron from the water. Some
                ! studies (especially at Papa) have shown this uptake to be significant
-               ! ----------------------------------------------------------
+               ! ---------------------------------------------------------------------
                zbactfer = feratb *  rfact2 * 0.6_wp / rday * tgfunc(ji,jj,jk) * xlimbacl(ji,jj,jk)     &
                   &              * trb(ji,jj,jk,jpfer) / ( xkferb + trb(ji,jj,jk,jpfer) )    &
                   &              * zdepeff(ji,jj,jk) * zdepbac(ji,jj,jk)
+
+               ! Only the transfer of iron from its dissolved form to particles
+               ! is treated here. The GGE of bacteria supposed to be equal to 
+               ! 0.33. This is hard-coded. 
                tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) - zbactfer*0.33
                tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zbactfer*0.25
@@ -242,14 +260,16 @@
       ! of bSi. Set to a constant in the upper ocean
       ! ---------------------------------------------------------------
-
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
+               ! Remineralization rate of BSi depedant on T and saturation
+               ! The parameterization is taken from Ridgwell et al. (2002) 
+               ! ---------------------------------------------------------
                zdep     = MAX( hmld(ji,jj), heup_01(ji,jj) )
                zsatur   = MAX( rtrn, ( sio3eq(ji,jj,jk) - trb(ji,jj,jk,jpsil) ) / ( sio3eq(ji,jj,jk) + rtrn ) )
                zsatur2  = ( 1. + tsn(ji,jj,jk,jp_tem) / 400.)**37
                znusil   = 0.225  * ( 1. + tsn(ji,jj,jk,jp_tem) / 15.) * zsatur + 0.775 * zsatur2 * zsatur**9.25
-               ! Remineralization rate of BSi depedant on T and saturation
-               ! ---------------------------------------------------------
+               ! Computation of the vertical evolution of the labile fraction
+               ! of bSi. This is computed assuming steady state.
                IF ( gdept_n(ji,jj,jk) > zdep ) THEN
                   zfacsib(ji,jj,jk) = zfacsib(ji,jj,jk-1) * EXP( -0.5 * ( xsiremlab - xsirem )  &
@@ -261,5 +281,5 @@
                zsiremin = ( xsiremlab * zfacsi(ji,jj,jk) + xsirem * ( 1. - zfacsi(ji,jj,jk) ) ) * xstep * znusil
                zosil    = zsiremin * trb(ji,jj,jk,jpgsi)
-               !
+               ! Update of the TRA arrays
                tra(ji,jj,jk,jpgsi) = tra(ji,jj,jk,jpgsi) - zosil
                tra(ji,jj,jk,jpsil) = tra(ji,jj,jk,jpsil) + zosil
